cog/urls.py
#
# Copyright 2014, Martin Owens <doctormo@gmail.com>
#
# This file is part of the software inkscape-web, consisting of custom
# code for the Inkscape project's django-based website.
#
# inkscape-web is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# inkscape-web is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with inkscape-web.  If not, see <http://www.gnu.org/licenses/>.
#
"""Main website urls, from here all other things sprong"""

from django.conf.urls import url

from .views import ErrorList, ErrorDetail, MarkFixed, WebsiteStats

app_name = 'cog'

urlpatterns = [
    url(r'^errors/$', ErrorList.as_view(), name='errors'),
    url(r'^errors/(?P<slug>[^\/]*)/$', ErrorDetail.as_view(), name='error'),
    url(r'^errors/(?P<slug>[^\/]*)/fix/$', MarkFixed.as_view(), name='fix'),
    url(r'^stats/$', WebsiteStats.as_view(), name='stats'),
]

cog/templates/cog/error_detail.html
{% extends "admin/index.html" %}
{% load i18n inkscape %}

{% block extrastyle %}{{ block.super }}
<style>
.traceback {
  background-color: #ffc;
  margin: 10px;
  width: 100%;
}
.traceback td {
  padding: 3px;
}
.traceback td.center {
  text-align: center;
}
.traceback tr td:first-child {
  color: white;
  width: 1%;
  padding: 5px;
  text-align: center;
}
tr.unknown td:first-child { color: #888; }
tr.sys td:first-child { background-color: #800; }
tr.env td:first-child { background-color: #008; }
tr.web td:first-child { background-color: #080; }

code {
  padding: 10px;
}

.traceback tr td.content {
  background-color: white;
  color: #444;
  text-align: left;
}
.fixed {
  background-color: #ff0;
}
.dashboard #content {
  width: 990px;
}
</style>
{% endblock %}

{% block sidebar %}{% endblock %}

{% block content %}
  <ul>
    {% if object.fixed %}
      <li class="fixed">Fixed {{ object.fixed|timesince }} ago | {{ object.fixed }}</li>
    {% endif %}
    <li>First Seen {{ object.started|timesince }} ago | {{ object.started }}</li>
    <li>Last Seen {{ object.ended|timesince }} ago | {{ object.ended }}</li>
    <li>Seen {{ object.count }} times</li>
  </ul>

  <hr/>
  <code>
    {{ object.description }}
  </code>

  <hr/>
  <ul>
    {% for url in object.get_urls %}
      <li><a href="{{ url }}">{{ url }}</a></li>
    {% endfor %}
  </ul>
  <hr/>

  <table class="traceback">
    <tr>
      <th scope="col">Package</th>
      <th scope="col">File</th>
      <th scope="col">Line</th>
      <th scope="col">Function</th>
    </tr>
    {% for tb in object.get_traceback %}
      <tr class="{{ tb.class }}">
        <td title="{{ tb.class }}">{{ tb.pkg }}</td>
        <td>{{ tb.file }}</td>
        <td class="center">{{ tb.line }}</td>
        <td>{{ tb.func }}</td>
      </tr>
      {% if tb.content %}
        <tr>
            <td class="content" colspan="4"><code>{{ tb.content }}</code></td>
        </tr>
      {% endif %}
    {% endfor %}
  </table>
{% endblock %}

cog/templates/cog/error_list.html
{% extends "admin/base_site.html" %}
{% load i18n inkscape static %}

-{% block extrastyle %}{{ block.super }}
<style>
.dashboard #content {
  width: 990px;
}
table td {
  text-align: left;
  white-space: nowrap;
}
table td.name {
  overflow: hidden;
  background-color: #fafafa;
  text-overflow: ellipsis;
  max-width: 450px;
}
.fixed {
  background-color: #8c0;
  text-align: center;
  padding: 5px;
}
.tofix a {
  color: white;
  background-color: #800;
  text-align: center;
  padding: 5px;
}
</style>
{% endblock %}

{% block sidebar %}{% endblock %}

{% block content %}
<div id="changelist">
  <table id="results_list">
    <thead>
    <tr>
      {% for header in headers %}
      <th scope="col" class="sortable{% if header.sorted %} sorted {% if header.accending %}accending{% else %}descending{% endif %}{% endif %}">
         <div class="sortoptions">
           <a class="sortremove" href="?order=" title="Remove from sorting"></a>
           <a href="?order={{ header.next }}" class="toggle {% if header.accending %}ascending{% else %}descending{% endif %}" title="Toggle sorting"></a>
         </div>
         <div class="text"><a href="?order={{ header.next }}">{{ header.name }}</a></div>
      </th>
      {% endfor %}
    </tr>
    </thead>
    <tbody>
    {% for error in object_list %}
      <tr>
        <td>{{ error.count }}</td>
        <td class="name"><a href="{{ error.get_absolute_url }}">{{ error.name }}</a></td>
        <td>{{ error.started|date:"M D dS" }} {{ error.started|time:"fA" }}</td>
        <td title="{{ error.ended|date:"M D dS" }} {{ error.ended|time:"fA" }}">{{ error.ended|timesince }}</td>
        {% if error.fixed %}
          <td class="fixed">{{ error.fixed|timesince }}</td>
        {% else %}
          <td class="tofix"><a href="{% url "cog:fix" error.traceback_id %}">Mark Fixed</a></td>
        {% endif %}
      </tr>
    {% endfor %}
    </tbody>
  </table>
</div>
{% endblock %}

cog/templates/cog/website_stats.html
{% extends "modal.html" %}
{% load i18n static inkscape %}

{% block title %}{% trans "Website Statistics" %}{% endblock %}

{% block "js" %}{{ block.super }}
  {{ stats.media }}
{% endblock %}

{% block "dialog-subtitle" %}
    <form method="GET" action="">
      <table class="table table-forum table-hover" style="width: 100%">
        <tbody>
          <tr class="active">
            <td>
                <select name="cadence" style="width: 100%">
<option value="week" {% if request.GET.cadence == "week" %}selected{% endif %}>Weekly</option>
<option value="day" {% if request.GET.cadence == "day" %}selected{% endif %}>Daily</option>
<option value="month" {% if request.GET.cadence == "month" %}selected{% endif %}>Monthly</option>
<option value="year" {% if request.GET.cadence == "year" %}selected{% endif %}>Yearly</option>
                </select>
            </th>
            <td><input type="text" placeholder="From (date/count)" name="from" value="{{ request.GET.from }}"/></th>
            <td><input type="text" placeholder="To (date/count)" name="to" value="{{ request.GET.to }}"/></th>
            <td class="text-right"><button type="submit">Filter</button></th>
          </tr>
        </tbody>
      </table>
    </form>
{% endblock %}

{% block "dialog-body" %}
  {% for stat in stats %}
    {{ stat.render }}
    <hr/>
  {% endfor %}
{% endblock %}